function love.load()
	math.randomseed(os.time())
	love.window.setTitle("Silver Sweeper")
	w, h = love.graphics.getDimensions()

	require("main_menu")
	require("tile")
	require("game")
end

function love.update(dt)

end

function love.draw()
	if game.is_active then
		game:Draw()
	end

	if menu.is_active then
		menu:Draw()
	end
end

function love.keypressed(k)
	if not menu.is_active then
		if game.is_active then
			if k == "escape" then
				menu.is_active = true
			end
		end
		return
	end
	
	if game.is_active then
		if k == "escape" then
			menu.is_active = false
		end
	end
	
	if k == "return" then
		menu:GetSelected().on_select()
	end

	if k == "up" or k == "left" then
		menu:Next(-1)
	elseif k == "down" or k == "right" then
		menu:Next(1)
	end
end

function love.mousepressed(x, y, b)
	if game.is_active and not menu.is_active then	
		local tile
		local brk = false
			
		for c = 1, game.w do
			if brk then
				break
			end
		
			for r = 1, game.h do
				local t = game[c][r]
				local size = t.size
				
				if x <= t.start_x + size and y <= t.start_y + size and x >= t.start_x and y >= t.start_y then
					tile = t
					brk = true
					break
				end
			end
		end

		if not tile then
			return
		end
		
		selected_tile = tile
	end
end

function love.mousereleased(x, y, b)
	if game.is_active and not menu.is_active then	
		local tile
		local brk = false
			
		for c = 1, game.w do
			if brk then
				break
			end
		
			for r = 1, game.h do
				local t = game[c][r]
				local size = t.size
				
				if x <= t.start_x + size and y <= t.start_y + size and x >= t.start_x and y >= t.start_y then
					tile = t
					brk = true
					break
				end
			end
		end

		if not tile then
			return
		end
		
		if selected_tile == tile then
			if b == 1 then
				tile:OnLeftClick()
			elseif b == 2 then
				tile:OnRightClick()
			end
		end
		
		selected_tile = nil
	end
end
